     h**********************************************************************
     h* Pgm : MSRFTPAC
     h* Desc: FTP retrieve access level permitted
     h* Date: 09/24/99 written by Alex Garrison
     h* Note:
     h*  1. FTP users are either granted 'C' customer access which is
     h*     highly restricted or 'F' full access.
     h*  2. Users are also classed as 'I' inactive or 'A' active.
     h*  3. THIS PROGRAM IS PROVIDED "AS-IS" WITHOUT ANY
     h*     GUARANTEE OR IMPLIED FITNESS FOR ANY SPECIFIC PURPOSE.
     h*     ALEX GARRISON AND MIDRANGE COMPUTING MAKE NO CLAIMS
     h*     REGARDING THE RELIABILITY, SERVICEABILITY, PERFORMANCE, OR
     h*     FUNCTION OF THIS PROGRAM.  AS WITH ALL PROGRAMS THE USER
     h*     IS CAUTIONED TO MAKE RELEVANT BACKUPS AND CAREFULLY TEST
     h*     THE PROGRAM.
     h*
     h**********************************************************************
     fmspftpus  if   e           k disk
     d*
     d wusrprf         s             10a
     d wactive         s              1a
     d waccess         s              1a
     c*
     c* Parameter Definitions
     c     *entry        plist
     c                   parm                    wusrprf                        I  User profile
     c                   parm                    wactive                        O  A/I
     c                   parm                    waccess                        O  F/C
     c*
     c* Main Procedure
     c*
     c*                  default response is not active, lowest access
     c                   eval      wactive = 'I'
     c                   eval      waccess = 'C'
     c*                  check access level allowed
     c     wusrprf       chain     mspftpus                           30
     c     *in30         ifeq      *off
     c                   eval      wactive = ftactive
     c                   eval      waccess = ftaccess
     c                   endif
     c                   move      *on           *inlr
