     h**********************************************************************
     h* Pgm : MSRFTPSC
     h* Desc: FTP server security exit program
     h* Date: 09/24/99 written by Alex Garrison
     h* Note:
     h*  1. FTP users must have a valid user profile and be flagged as
     h*     active in the MSPFTPUS file.
     h*  2. THIS PROGRAM IS PROVIDED "AS-IS" WITHOUT ANY
     h*     GUARANTEE OR IMPLIED FITNESS FOR ANY SPECIFIC PURPOSE.
     h*     ALEX GARRISON AND MIDRANGE COMPUTING MAKE NO CLAIMS
     h*     REGARDING THE RELIABILITY, SERVICEABILITY, PERFORMANCE, OR
     h*     FUNCTION OF THIS PROGRAM.  AS WITH ALL PROGRAMS THE USER
     h*     IS CAUTIONED TO MAKE RELEVANT BACKUPS AND CAREFULLY TEST
     h*     THE PROGRAM.
     h*
     h**********************************************************************
     fmspftpus  uf   e           k disk
     d*
     d appid           s              9b 0
     d usridBuf        s             10
     d usrid           s             10
     d usridLen        s              9b 0
     d authStrBuf      s             10
     d authStr         s             10
     d authStrLen      s              9b 0
     d cliIpBuf        s             15
     d cliIp           s             15
     d cliIPLen        s              9b 0
     d rtnCd           s              9b 0
     d usrPrf          s             10a
     d pswd            s             10a
     d curLib          s             10a
     d*
     d prfHndl         s             12a
     d maxLen          s              5i 0
     d*
     d SysDtTm         s             12p 0
     d CurDt           s               d   datfmt(*ymd/)
     d CurTm           s               t   timfmt(*hms:)
     d CurDtTm         s               z
     d
     c*
     c* Parameter Definitions
     c     *entry        plist
     c                   parm                    appid                          I  0=client 1=server
     c                   parm                    usridBuf                       I  client userid
     c                   parm                    usridLen                       I
     c                   parm                    authStrBuf                     I  client password
     c                   parm                    authStrLen                     I
     c                   parm                    cliIpBuf                       I  client ip address
     c                   parm                    cliIpLen                       I
     c                   parm                    rtnCd                          O  0=no 1=yes
     c                   parm                    usrPrf                         O  not used
     c                   parm                    pswd                           O  not used
     c                   parm                    curLib                         O  not used
     c*
     c* Main Procedure
     c*
     c*                  default to not allow login
     c                   eval      rtnCd = 0
     c                   eval      prfHndl = ' '
     c*
     c*                  validate input parms
     c                   if        usridLen <= 0
     c                   eval      usrid = ' '
     c                   else
     c                   if        usridLen > 10
     c                   eval      maxLen = 10
     c                   else
     c                   eval      maxLen = usridLen
     c                   endif
     c                   eval      usrid = %subst(usridBuf:1:maxLen)
     c                   endif
     c*
     c                   if        authStrLen <= 0
     c                   eval      authStr = ' '
     c                   else
     c                   if        authStrLen > 10
     c                   eval      maxLen = 10
     c                   else
     c                   eval      maxLen = authStrLen
     c                   endif
     c                   eval      authStr = %subst(authStrBuf:1:maxLen)
     c                   endif
     c*
     c                   if        cliIpLen <= 0
     c                   eval      cliIp = ' '
     c                   else
     c                   if        cliIpLen > 15
     c                   eval      maxLen = 15
     c                   else
     c                   eval      maxLen = cliIpLen
     c                   endif
     c                   eval      cliIp = %subst(cliIpBuf:1:maxLen)
     c                   endif
     c
     c*                  validate the userid and authStr (password)
     c*                  with as/400 security.
     c                   call      'QSYGETPH'                           30
     c                   parm                    usrid
     c                   parm                    authStr
     c                   parm                    prfHndl
     c                   if        prfHndl <> ' '
     c*                  valid. now check ftp authority
     c*                  and record login in the ftp user file
     c     usrid         chain     mspftpus                           30
     c                   if        *in30 = *off
     c                   if        ftactive = 'A'
     c*                  this user is active, so allow login
     c                   eval      rtnCd = 1
     c                   endif
     c*                  record login date/time (whether successful or not)
     c                   time                    SysDtTm
     c     *jobrun       move      SysDtTm       CurDt
     c     *jobrun       movel     SysDtTm       CurTm
     c                   move      CurDt         CurDtTm
     c                   move      CurTm         CurDtTm
     c                   eval      ftllogin = CurDtTm
     c                   eval      ftip = cliIp
     c                   update    rftpus
     c                   endif
     c                   endif
     c                   eval      *inlr = *on
